Summary: The VIM editor.
Name: vim
%define base_vers 7.2
Version: %{base_vers}
%define vimversion vim72
URL: http://www.vim.org
Release: 1
License: IBM_ILA
Group: Applications/Editors
Source0: ftp://ftp.vim.org/pub/vim/unix/vim-%{base_vers}.tar.bz2
Source1: IBM_ILA
Buildroot: /var/tmp/%{name}-root
Buildrequires: python-devel perl
Prefix: %{_prefix}
%define DEFCC cc

%description
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still very
popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.

%package common
Summary: The common files needed by any version of the VIM editor.
Group: Applications/Editors

%description common
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still very
popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-common package contains
files which every VIM binary will need in order to run.

If you are installing any version of the VIM editor, you'll also need to the
vim-common package installed.

%package minimal
Summary: A minimal version of the VIM editor.
Group: Applications/Editors
Requires: vim-common
Obsoletes:  vim

%description minimal
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still very
popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more. The vim-minimal package includes
a minimal version of VIM.

%package enhanced
Summary: A version of the VIM editor which includes recent enhancements.
Group: Applications/Editors
Requires: vim-common
Obsoletes: vim-color

%description enhanced
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still very
popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more.  The vim-enhanced package
contains a version of VIM with extra, recently introduced features like Python
and Perl interpreters.

Install the vim-enhanced package if you'd like to use a version of the VIM
editor which includes recently added enhancements like interpreters for the
Python and Perl scripting languages.  You'll also need to install the
vim-common package.

%package X11
Summary: The VIM version of the vi editor for the X Window System.
Group: Applications/Editors
Requires: vim-common

%description X11
VIM (VIsual editor iMproved) is an updated and improved version of the vi
editor.  Vi was the first real screen-based editor for UNIX, and is still very
popular.  VIM improves on vi by adding new features: multiple windows,
multi-level undo, block highlighting and more. VIM-X11 is a version of the VIM
editor which will run within the X Window System.  If you install this package,
you can run VIM as an X application with a full GUI interface and mouse
support.

Install the vim-X11 package if you'd like to try out a version of vi with
graphics and mouse capabilities.  You'll also need to install the vim-common
package.

%prep
# Don't proceed with build if /usr/local/lib exists
# It's going to build with that in its libpath, which we don't want
# for the Toolbox.  (Other users reading this file who do want /usr/local/lib
# may wish to remove this part).
if [[ -d /usr/local/lib ]] ; then
  echo "For the Toolbox, don't build this on a system with /usr/local/lib"
  echo "(or at least, temporarily move it).  We don't want it!"
  exit 1
fi

%setup -q -n %{vimversion}
perl -pi -e "s,bin/nawk,bin/awk,g" runtime/tools/mve.awk

# Add license info
cat $RPM_SOURCE_DIR/IBM_ILA > LICENSE
cat ./runtime/doc/uganda.txt >> LICENSE

%build
# Use the default compiler for this platform - gcc otherwise
if [[ -z "$CC" ]]
then
    if test "X`type %{DEFCC} 2>/dev/null`" != 'X'; then
       export CC=%{DEFCC}
    else
       export CC=gcc
    fi
fi
if test "X$CC" != "Xgcc"
then
       export RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed 's:-fsigned-char::'`
       export CFLAGS="$RPM_OPT_FLAGS"
fi
cd src
perl -pi -e "s,\\\$VIMRUNTIME,/usr/share/vim/%{vimversion},g" os_unix.h
perl -pi -e "s,\\\$VIM,/usr/share/vim/%{vimversion}/macros,g" os_unix.h

export CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64"
export CXXFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64"

#export PYTHONHOME=%{_prefix}/lib/python2.1/plat-aix4

%configure --with-features=huge --enable-pythoninterp --enable-perlinterp --disable-tclinterp --with-x=yes --enable-gui=gtk --exec-prefix=%{prefix} --enable-xim --enable-multibyte --enable-fontset
make
cp vim gvim
make clean

%configure --prefix=%{_prefix} --with-features=huge --enable-pythoninterp \
 --disable-perlinterp --disable-tclinterp --with-x=no --enable-gui=no \
 --exec-prefix=%{_prefix} --enable-multibyte --enable-fontset
make
cp vim enhanced-vim
make clean

%configure --prefix=%{_prefix} --with-features=tiny --with-x=no \
  --disable-pythoninterp --disable-perlinterp --disable-tclinterp \
  --with-tlib=curses --enable-gui=no --disable-gpm --exec-prefix=/
make


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/bin
mkdir -p $RPM_BUILD_ROOT%{_prefix}/share/vim
mkdir -p $RPM_BUILD_ROOT/usr/lpp/X11/bin
mkdir -p $RPM_BUILD_ROOT/usr/linux/bin

cd src
make DESTDIR=$RPM_BUILD_ROOT install
make installmacros DESTDIR=$RPM_BUILD_ROOT
install -m755 gvim $RPM_BUILD_ROOT/usr/lpp/X11/bin
install -m755 enhanced-vim $RPM_BUILD_ROOT%{_prefix}/bin/enhanced-vim

( cd $RPM_BUILD_ROOT
  mv .%{prefix}/bin/vim .%{prefix}/bin/vi
  mv .%{prefix}/bin/enhanced-vim .%{prefix}/bin/vim
  ln -sf vi .%{prefix}/bin/rvi
  ln -sf vi .%{prefix}/bin/rview
  ln -sf vi .%{prefix}/bin/view
  ln -sf vi .%{prefix}/bin/ex
  rm -f .%{prefix}/bin/rvim
  ln -sf gvim ./usr/lpp/X11/bin/gview
  ln -sf gvim ./usr/lpp/X11/bin/gex
  perl -pi -e "s,$RPM_BUILD_ROOT,," .%{_mandir}/man1/vim.1 .%{_mandir}/man1/vimtutor.1
  rm -f .%{_mandir}/man1/rvim.1
  ln -sf vim.1 .%{_mandir}/man1/vi.1
  ln -sf vim.1 .%{_mandir}/man1/rvi.1
  ln -sf vim.1 .%{_mandir}/man1/gvim.1
  ln -sf gvim ./usr/lpp/X11/bin/vimx
)

( cd $RPM_BUILD_ROOT
  mkdir -p ./etc/X11/applnk/Utilities
  cat > ./etc/X11/applnk/Utilities/gvim.desktop <<EOF
[Desktop Entry]
Name=gvim
Type=Application
Comment=VI editor for X Windows
Exec=gvim
EOF
)

#Make GNOME and KDE desktop links
CATEGORY=Utilities
APP=gvim
KDELNK=$RPM_BUILD_ROOT%{prefix}/kde/share/applnk
GNOMELNK=$RPM_BUILD_ROOT%{prefix}/share/gnome/apps
mkdir -p $KDELNK/$CATEGORY
mkdir -p $GNOMELNK/$CATEGORY
ln -s /etc/X11/applnk/$CATEGORY/$APP.desktop $KDELNK/$CATEGORY
ln -s /etc/X11/applnk/$CATEGORY/$APP.desktop $GNOMELNK/$CATEGORY

(cd $RPM_BUILD_ROOT
 /usr/bin/strip ./%{prefix}/bin/* || :
 for dir in bin share
 do
    mkdir -p usr/$dir
    cd usr/$dir
    ln -sf ../..%{prefix}/$dir/* .
    cd -
 done

 cd usr/linux/bin
 for link in vi ex view rview rvi
 do
    ln -s ../../..%{prefix}/bin/vi $link
 done
 cd -

 rm usr/bin/vi usr/bin/view usr/bin/ex
)


# Dependency cleanups
chmod 644 $RPM_BUILD_ROOT%{prefix}/share/vim/%{vimversion}/doc/vim2html.pl \
 $RPM_BUILD_ROOT%{prefix}/share/vim/%{vimversion}/tools/*.pl \
 $RPM_BUILD_ROOT%{prefix}/share/vim/%{vimversion}/tools/vim132
chmod 644 ../runtime/doc/vim2html.pl

%clean
rm -rf $RPM_BUILD_ROOT

%files common
%defattr(-,root,system)
%doc README*.txt runtime/macros/README.txt runtime/tools/README.txt LICENSE
%doc runtime/doc runtime/syntax runtime/termcap runtime/tutor
%doc runtime/*.vim
%{prefix}/bin/vimtutor
%{prefix}/bin/xxd
/usr/bin/vimtutor
/usr/bin/xxd

%{prefix}/share/vim
/usr/share/vim
%{_mandir}/man1/vim.*
%{_mandir}/man1/vimtutor.*
%{_mandir}/man1/ex.*
%{_mandir}/man1/vi.*
%{_mandir}/man1/view.*
%{_mandir}/man1/rvi.*
%{_mandir}/man1/rview.*
%{_mandir}/man1/xxd.*

%files minimal
%defattr(-,root,system)
%doc LICENSE
%{prefix}/bin/ex
%{prefix}/bin/vi
%{prefix}/bin/view
%{prefix}/bin/rview
%{prefix}/bin/rvi
/usr/linux/bin/ex
/usr/linux/bin/vi
/usr/linux/bin/view
/usr/linux/bin/rvi
/usr/linux/bin/rview

%files enhanced
%defattr(-,root,system)
%doc LICENSE
%{prefix}/bin/vim
/usr/bin/vim

%files X11
%defattr(-,root,system)
%doc LICENSE
%config(missingok) /etc/X11/applnk/Utilities/gvim.desktop
%{prefix}/kde/share/applnk/*/*
%{prefix}/share/gnome/apps/*/*
/usr/lpp/X11/bin/gvim
/usr/lpp/X11/bin/gview
/usr/lpp/X11/bin/gex
/usr/lpp/X11/bin/vimx
%{_mandir}/man1/gvim.*

%changelog
* Wed Jul 1 2009 Jean Noel Cordenner <jean-noel.cordenner@bull.net> 7.2-1
- Update to version 7.2

* Fri Mar 23 2004 David Clissold <cliss@austin.ibm.com> 6.3-1
- Update to version 6.3

* Thu Mar 11 2004 David Clissold <cliss@austin.ibm.com> 6.0.147-4
- Rebuild; making sure we don't have /usr/local/lib on the build system
- because for the Toolbox, we don't want our binaries looking there.
- (vim adds -L/usr/local/lib first if it finds the directory present).

* Wed May 28 2003 David Clissold <cliss@austin.ibm.com>
- The 'vim' binary was not being stripped.
- Link rvi, rview, ex to vi and not vim as per bug rpt #3635.

* Fri Nov 22 2002 David Clissold <cliss@austin.ibm.com>
- Add IBM ILA license.

* Tue Apr 23 2002 David Clissold <cliss@austin.ibm.com>
- No functional change.  Remove controversial political designation
- from the original gzipped tarball.
- Also bump the version level (6.0.147) to match the vim
- entry screen, based on last patch level. (This is functionally
- no different than the 6.0-147 version).

* Tue Jan 22 2002 Marc Stephenson <marc@austin.ibm.com>
- Added most recent patches - to number 147

* Tue Oct 02 2001 Marc Stephenson <marc@austin.ibm.com>
- 6.0 for AIX Toolbox

* Fri Mar 30 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix large file handling (#34061)

* Mon Feb 26 2001 Trond Eivind Glomsrd <teg@redhat.com>
- use %%{_tmppath}

* Thu Feb 15 2001 Yukihiro Nakai <ynakai@redhat.com>
- vimrc update for 6.0v

* Mon Feb 12 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix "lba32" keyword in lilo.conf syntax highlighting
- Fix build with current glibc

* Fri Feb  2 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix crontab -e in vim-minimal (#25376)

* Tue Jan 30 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix segfault on q, up, up, q (Bug #25261)

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Set minlines=500 as default in PHP syntax highlighting (RFE #24374)
- Don't symlink gvimrc to vimrc (Bug #22518)
- Add symlinks gview -> gvim and gex -> gvim in -X11 (RFE #24394)
- 6.0t

* Mon Jan 15 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- More fixes to rpm specfile syntax highlighting:
  - recognize %%ifnarch
  - recognize "j" as a tar option
  - recognize %{_libdir}

* Sun Jan 14 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0s

* Wed Jan  3 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0r
- Restore crv patch (this should fix #23135 for whoever is seeing it;
  I'm not).

* Tue Dec 19 2000 Yukihiro Nakai <ynakai@redhat.com>
- Symbolic link to menu_ja_jp.ujis.vim to menu_ja_jp.eucjp.vim

* Mon Dec 18 2000 Yukihiro Nakai <ynakai@redhat.com>
- Delete i18n patch (already implmented by author)
- Add menu i18n patch
- Update vimrc to support CJK
- Add menu translations.

* Sun Dec 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0q

* Sun Dec 17 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add --enable-fontset to configure options.
- Add i18nrc patch and resources.

* Tue Dec 12 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0p, new ncurses

* Mon Dec 11 2000 Karsten Hopp <karsten@redhat.de>
- rebuilt to fix permissions of /usr/share/doc/ and
  /usr/share/vim

* Mon Nov 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0m

* Thu Nov  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0l

* Mon Oct 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0k

* Tue Oct 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0i
- add new desktop file w/ translations

* Thu Aug 31 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0h

* Wed Aug 30 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0g

* Mon Aug 14 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0f

* Wed Aug  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0e

* Sun Jul 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0c
- get rid of the DESTDIR patch, no longer needed

* Sun Jul 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0b

* Mon Jul 10 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 6.0a

* Sun Jun 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.7 release
- some more fixes to .spec file syntax highlighting rules... About time it
  recognizes %%{_mandir}...

* Sun Jun 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 5.7a

* Sat Jun  3 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- patchlevel 74
- add %%makeinstall macro recognition to .spec file syntax highlighting rules
- fix up Makefiles

* Fri Apr 14 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- patchlevel 66
- fix compilation with perl 5.6.0

* Mon Mar 20 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- patchlevel 12

* Tue Mar 07 2000 Preston Brown <pbrown@redhat.com>
- fix home/end in vimrc (we did a term = rxvt, totally wrong)

* Tue Feb 29 2000 Preston Brown <pbrown@redhat.com>
- change F1-F4 keybindings for xterm builtin terminfo to match real terminfo

* Thu Feb 17 2000 Bill Nottingham <notting@redhat.com>
- kill autoindent

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Sat Feb  5 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- Patchlevel 11
- handle compressed man pages
- fix man page symlinks

* Wed Feb  2 2000 Bill Nottingham <notting@redhat.com>
- eliminate dependencies on X in vim-enhanced, and ncurses/gpm
  in vim-minimal

* Fri Jan 28 2000 Bill Nottingham <notting@redhat.com>
- eliminate dependencies on csh and perl in vim-common

* Wed Jan 19 2000 Bernhard Rosenrknzer <bero@redhat.com>
- Use awk, not nawk

* Tue Jan 18 2000 Bernhard Rosenrknzer <bero@redhat.com>
- 5.6
- patch 5.6.001
- remove /usr/bin/vi - if you want vim, type vim

* Tue Jan 11 2000 Bernhard Rosenkrnzer <bero@redhat.com>
- 5.6a
- Remove dependency on nawk (introduced by base update)
- some tweaks to make updating easier

* Tue Nov  9 1999 Bernhard Rosenkrnzer <bero@redhat.com>
- 5.5
- fix path to vimrc

* Tue Jul 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved from athena to gtk widgets for X version
- removed vim.1 from X11 filelist because X11 depends on vim-common anyway
- fixed rogue dependencies from sample files

* Tue Jul 27 1999 Jeff Johnson <jbj@redhat.com>
- update to 5.4.

* Thu Jul 22 1999 Jeff Johnson <jbj@redhat.com>
- man page had buildroot pollution (#3629).

* Thu Mar 25 1999 Preston Brown <pbrown@redhat.com>
- with recent termcap/terminfo fixes, regular vim works in xterm/console
- in color, so vim-color package removed.

* Tue Mar 23 1999 Erik Troan <ewt@redhat.com>
- removed "set backupdir=/tmp/vim_backup" from default vimrc

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 5)

* Thu Dec 17 1998 Michael Maher <mike@redaht.com>
- built pacakge for 6.0

* Tue Sep 15 1998 Michael Maher <mike@redhat.com>
- removed '--with-tlib=termcap' so that color-vim works

* Wed Sep  2 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.3.

* Mon Aug 10 1998 Jeff Johnson <jbj@redhat.com>
- merge in Toshio's changes
- color-vim: changed "--disable-p" to "--disable-perlinterp --with-tlib=termcap"
- added minimal rvi/rview and man pages.
- move Obsoletes to same package as executable.

* Thu Aug 06 1998 Toshio Kuratomi <badger@prtr-13.ucsc.edu>
- Break the package apart similar to the way the netscape package was
  broken down to handle navigator or communicator: The vim package is
  Obsolete, now there is vim-common with all the common files, and a
  package for each binary: vim-minimal (has /bin/vi compiled with no
  frills), vim-enhanced (has /usr/bin/vim with extra perl and python
  interpreters), and vim-X11 (has /usr/X11R6/bin/gvim compiled with
  GUI support.)
- Enable the perl and python interpreters in the gui version (gvim).

* Tue Jun 30 1998 Michael Maher <mike@redhat.com>
- Fixed tutor help.
- cvim package added.  Thanks to Stevie Wills for finding this one :-)

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri May 01 1998 Donnie Barnes <djb@redhat.com>
- added patch to turn off the "vi compatibility" by default.  You can
  still get it via the -C command line option

* Thu Apr 23 1998 Donnie Barnes <djb@redhat.com>
- removed perl and python interpreters (sorry, but those don't belong
  in a /bin/vi and having two vi's seemed like overkill...complain
  to suggest@redhat.com if you care)

* Fri Apr 17 1998 Donnie Barnes <djb@redhat.com>
- fixed buildroot bug

* Sat Apr 11 1998 Donnie Barnes <djb@redhat.com>
- updated from 4.6 to 5.1
- moved to buildroot

* Sun Nov 09 1997 Donnie Barnes <djb@redhat.com>
- fixed missing man page

* Wed Oct 22 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry to vim-X11

* Mon Oct 20 1997 Donnie Barnes <djb@redhat.com>
- upgraded from 4.5 to 4.6

* Fri Jun 13 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Michael K. Johnson <johnsonm@redhat.com>
- Upgraded to 4.5
- Added ex symlinks

* Tue Mar 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- Added view symlink.
